#include <complex.h>
#include "pgraph.h"

#define W 681
#define H 681
#define X0 (3*W/4)
#define Y0 (H/2)
#define L 320.0

/*
 //   2 :
#define W 1361
#define H 1361
#define X0 (3*W/4)
#define Y0 (H/2)
#define L 640.0
*/
/*
// ,   :
#define W 1281
#define H 1281
#define X0 (W/2)
#define Y0 (H/2)
#define L 320.0
*/

uchar get_gray_color(double complex z0)
{
	double complex z = z0;
	for (uchar gray = 255; gray; gray--)
	{
		if (cabs(z) > 2)
			return gray;
		z = z * z + z0;
	}
	return 0;
}

// "-"   
int main()
{
	image *img = create_image(W, H);
	for (int i = 0; i < W; i++)
		for (int j = 0; j < H; j++)
		{
			double x = (i - X0) / L;
			double y = (j - Y0) / L;
			double complex z = x + I * y;
			uchar gray = get_gray_color(z);
			if (gray != 255)
				set_color(img, i, j, (color) {gray, gray, gray});
		}
	save_to_file(img, "out.bmp");
	free(img);
	return 0;
}
/*
// ""   
int main()
{
	uchar red[] = {0, 36, 73, 109, 146, 182, 219, 255};
	uchar *green = red;
	uchar blue[] = {0, 85, 170, 255};
	color colors[256];
	int m = 0;
	for (int i = 0; i < 8; i++)
		for (int j = 0; j < 8; j++)
			for (int k = 0; k < 4; k++)
				colors[m++] = (color) {red[i], green[j], blue[k]};
				//colors[m++] = (color) {red[i], blue[k], green[j]};
				//colors[m++] = (color) {blue[k], red[i], green[j]};
				//colors[m++] = (color) {green[j], blue[k], red[i]};
				//colors[m++] = (color) {blue[k], green[j], red[i]};
				//colors[m++] = (color) {green[j], red[i], blue[k]};
	image *img = create_image(W, H);
	for (int i = 0; i < W; i++)
		for (int j = 0; j < H; j++)
		{
			double x = (i - X0) / L;
			double y = (j - Y0) / L;
			double complex z = x + I * y;
			uchar num = get_gray_color(z);
			if (num != 255)
				set_color(img, i, j, colors[num]);
		}
	save_to_file(img, "out.bmp");
	free(img);
	return 0;
}
*/
